function [] = buttonCalculateOffsets(~, ~)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

global artoaWorkspace artoaDataInput;

%% Initialize required variables
soundsources = artoaDataInput.soundsources;
satData = artoaWorkspace.satData;

%% Calculate offsets

[
    artoaWorkspace.editOffsets.calculatedMatrixA, ...
    artoaWorkspace.editOffsets.calculatedMatrixB, ...
    artoaWorkspace.editOffsets.calculatedMatrixX ...
] = artoa.offsets.solve( ...
    artoaDataInput.rfb, ...
    soundsources, ...
    artoaWorkspace.trackParameter, ...
    artoaWorkspace.toaData, ...
    satData, ...
    artoaWorkspace.temperature(artoaWorkspace.statusTemperature == 1), ...
    artoaWorkspace.pressure(artoaWorkspace.statusPressure == 1), ...
    artoa.data.getMember(artoaDataInput, {'ini', 'leapseconds'}) ...
);

%% Store offsets in table
[offsets, drifts] = artoa.offsets.extractOffsetsDriftsFromSolved(artoaWorkspace.editOffsets.calculatedMatrixX);

soundsourceNames = fieldnames(soundsources);
for o = 1:length(soundsourceNames)
    if ~any(contains(artoaWorkspace.editOffsets.soundsourceOffsets.Properties.RowNames, soundsourceNames{o}))
        continue;
    end
    artoaWorkspace.editOffsets.soundsourceOffsets{soundsourceNames{o}, 'OptimumTotalOffset'} = offsets(o);
    artoaWorkspace.editOffsets.soundsourceOffsets{soundsourceNames{o}, 'OptimumTotalDrift'} = drifts(o);
end

artoa.controller.edit.offsets.tableSoundsourceOffsetsEdit();



artoa.controller.edit.timeOfArrival.plot();

end

