function [] = open(~, ~)
%OPEN Initializes the offset details gui.
%   Detailed explanation goes here

global artoaGui artoaWorkspace;

%% Check if the gui is already opened

if isfield(artoaGui.figures, 'editOffsets')
    figure(artoaGui.figures.editOffsets);
    return
end

%% Setup callbacks

callbacks = struct();
callbacks.tableSoundsourceOffsetsEdit = @artoa.controller.edit.offsets.tableSoundsourceOffsetsEdit;
callbacks.buttonCalculateOffsets = @artoa.controller.edit.offsets.buttonCalculateOffsets;
callbacks.checkboxUseOffsets = @artoa.controller.edit.offsets.checkboxUseOffsets;

%% Open the gui
artoa.gui.edit.offsets(callbacks);

if artoa.data.hasMember(artoaWorkspace, {'editOffsets'})
    artoa.controller.edit.offsets.updateGui();
    return;
end

%% Create workspace variables
artoaWorkspace.editOffsets = struct();
artoaWorkspace.editOffsets.useOffsets = false;
artoa.controller.edit.offsets.updateWorkspaceOffsetsTable();

%% Update gui
artoa.controller.edit.offsets.updateGui();

end

