function [] = tableSoundsourceOffsetsEdit(~, event)
%TABLESOUNDSOURCEOFFSETSEDIT Summary of this function goes here
%   Detailed explanation goes here


global artoaGui artoaWorkspace artoaDataInput;

%% Get data
try
    selectedColumn = event.Indices(2);
catch
    selectedColumn = NaN;
    artoa.controller.edit.offsets.updateGui();
    return;
end

%% Check if the column that has been edited is locked
if 1 <= selectedColumn & selectedColumn <= 7
    artoa.controller.edit.offsets.updateGui();
    return;
end

if ~artoa.data.hasMember(artoaWorkspace, {'editOffsets', 'soundsourceOffsets'})
    return;
end

%% Save to workspace
artoaWorkspace.editOffsets.soundsourceOffsets(:, :) = artoaGui.editOffsets.tableSoundsourceOffsets.Data;

%% Recalculate drift
artoa.controller.edit.offsets.updateWorkspaceOffsetsTable();

%% Select offset and drift from the table
artoa.controller.edit.offsets.selectOffsetsAndDrift();
% combine initial toa and current applied soundsources
toaData = artoaWorkspace.toaData;
toaData.toa = artoaDataInput.toaData.toa;

artoaWorkspace.toaData = artoa.toa.recalculate( ...
    artoaWorkspace.float, ...
    toaData, ...
    artoaWorkspace.editOffsets.selectedOffsets ...
);

%% Calculate GPS TOAs
artoa.controller.edit.timeOfArrival.calculateGpsToas();

%% Update GUI
artoa.controller.edit.offsets.updateGui();

%% Replot TOA window
artoa.controller.edit.timeOfArrival.plot();

end
