function [offsetTable] = generateOffsetTable(pFloatDetails, pSoundsources)
%GETDEFAULTOFFSETTABLE Summary of this function goes here
%   Detailed explanation goes here

%% Get required variables
variableNames = artoa.offsets.getDefaultVariableNames();

%% Initialize return variable
offsetTable = cell2table( ...
    artoa.offsets.getDefaultRowValues(), ...
    'VariableNames', variableNames ...
);

%% Setup rows
offsetTable.Properties.RowNames(1) = {'Float'};
offsetTable{1, variableNames{1}} = artoa.convert.dmy2rd(pFloatDetails.launchtime(3), pFloatDetails.launchtime(2), pFloatDetails.launchtime(1));
offsetTable{1, variableNames{3}} = artoa.convert.dmy2rd(pFloatDetails.recovertime(3), pFloatDetails.recovertime(2), pFloatDetails.recovertime(1));

if nargin == 1
    return;
end

if iscell(pSoundsources)
    for i = 1:length(pSoundsources)
        offsetTable(i + 1, :) = artoa.offsets.getDefaultRowValues();
        offsetTable.Properties.RowNames(i + 1) = {pSoundsources{i}.sourcename};
        offsetTable{i + 1, variableNames{1}} = artoa.convert.dmy2rd(pSoundsources{i}.offset(3), pSoundsources{i}.offset(2), pSoundsources{i}.offset(1));
        offsetTable{i + 1, variableNames{2}} = pSoundsources{i}.offset(4);
        offsetTable{i + 1, variableNames{3}} = artoa.convert.dmy2rd(pSoundsources{i}.rcv_offset(3), pSoundsources{i}.rcv_offset(2), pSoundsources{i}.rcv_offset(1));
        offsetTable{i + 1, variableNames{4}} = pSoundsources{i}.rcv_offset(4);
        offsetTable{i + 1, variableNames{5}} = pSoundsources{i}.drift;
        offsetTable{i + 1, variableNames{8}} = pSoundsources{i}.empiric_offset(4);
        offsetTable{i + 1, variableNames{9}} = pSoundsources{i}.empiric_drift;
    end
end

if isstruct(pSoundsources)
    fnames = fieldnames(pSoundsources);
    for i = 1:length(fnames)
        offsetTable(i + 1, :) = artoa.offsets.getDefaultRowValues();
        offsetTable.Properties.RowNames(i + 1) = {pSoundsources.(fnames{i}).sourcename};
        offsetTable{i + 1, variableNames{1}} = artoa.convert.dmy2rd(pSoundsources.(fnames{i}).offset(3), pSoundsources.(fnames{i}).offset(2), pSoundsources.(fnames{i}).offset(1));
        offsetTable{i + 1, variableNames{2}} = pSoundsources.(fnames{i}).offset(4);
        offsetTable{i + 1, variableNames{3}} = artoa.convert.dmy2rd(pSoundsources.(fnames{i}).rcv_offset(3), pSoundsources.(fnames{i}).rcv_offset(2), pSoundsources.(fnames{i}).rcv_offset(1));
        offsetTable{i + 1, variableNames{4}} = pSoundsources.(fnames{i}).rcv_offset(4);
        offsetTable{i + 1, variableNames{5}} = pSoundsources.(fnames{i}).drift;
        offsetTable{i + 1, variableNames{8}} = pSoundsources.(fnames{i}).empiric_offset(4);
        offsetTable{i + 1, variableNames{9}} = pSoundsources.(fnames{i}).empiric_drift;
    end
end

end

